#
# Conditional build:
%bcond_without	doc		# don't rebuild documentation

Summary:	C compiler for Intel 8051 and Zilog Z80
Summary(pl.UTF-8):	Kompilator C dla Intel 8051 i Zilog Z80
Name:		sdcc
Version:	3.6.0
Release:	3
License:	GPL v2+ (tools), GPL v2+ with linking exception (runtime)
Group:		Development/Languages
Source0:	http://downloads.sourceforge.net/sdcc/%{name}-src-%{version}.tar.bz2
# Source0-md5:	4c4cf17d8d2b2d37af66c5b7511f62d8
# texlive 2008 is too old to create this file on the fly...
# (and too old to cope with PDF 1.5, which current gs creates by default)
# so create it manually from (generated) doc/MCS51_named.eps, forcing PDF 1.3 by:
# epstopdf sdcc-3.6.0/doc/MCS51_named.eps --nogs | /usr/bin/gs -q -sDEVICE=pdfwrite -dAutoRotatePages=/None -sOutputFile=MCS51_named.pdf -dCompatibilityLevel=1.3 - -c quit
Source1:	MCS51_named.pdf
# Source1-md5:	3212cd96c0ab1ac1def470a511dd4a06
URL:		http://sdcc.sourceforge.net/
BuildRequires:	bison
BuildRequires:	boost-devel
BuildRequires:	flex
BuildRequires:	gc-devel
BuildRequires:	gputils >= 1.4.2
BuildRequires:	libstdc++-devel
BuildRequires:	python >= 1:2.4
BuildRequires:	sed >= 4.0
%if %{with doc}
BuildRequires:	latex2html
BuildRequires:	lyx >= 1.4.4
BuildRequires:	texlive-fonts-cmsuper
BuildRequires:	texlive-fonts-type1-urw
BuildRequires:	texlive-format-pdflatex
BuildRequires:	texlive-latex-ams
BuildRequires:	texlive-makeindex
# rungs (for eps to pdf conversion in texlive)
BuildRequires:	texlive-other-utils
BuildRequires:	texlive-tex-babel
BuildRequires:	texlive-tex-xkeyval
BuildRequires:	texlive-xetex
%endif
Obsoletes:	ucsim
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define         _noautostrip    .*%{_datadir}/%{name}/.*

%description
SDCC is retargettable, optimizing ANSI-C compiler. The current version
targets the Intel 8051 and recently the Zilog Z80 based MCUs. SDCC can
be retargeted for other 8 bit MCUs or PICs and some day soon will be.
Supported data types are short (8 bits, 1 byte), char (8 bits, 1
byte), int (16 bits, 2 bytes), long (32 bit, 4 bytes) and float (4
byte IEEE). SDCC also comes with the source level debugger SDCDB.

%description -l pl.UTF-8
SDCC jest optymalizującym kompilatorem ANSI C dla wielu platform.
Aktualna wersja obsługuje procesory Intel 8051 oraz Zilog Z80. SDCC
może być łatwo zmodyfikowany by obsługiwać inne 8-bitowe jednostki.
Obsługiwane typy danych to short (8 bitów, 1 bajt), char (8 bitów, 1
bajt), int (16 bitów, 2 bajty), long (32 bity, 4 bajty) oraz float (4
bajty IEEE). SDCC dostarcza również debugger oparty na emulatorze
ucsim.

%package -n emacs-sdcdb
Summary:	SDCDB debugger support for Emacs
Summary(pl.UTF-8):	Obsługa debuggera SDCDB dla Emacsa
Group:		Development/Tools
Requires:	%{name} = %{version}-%{release}
Requires:	emacs

%description -n emacs-sdcdb
SDCDB debugger support for Emacs.

%description -n emacs-sdcdb -l pl.UTF-8
Obsługa debuggera SDCDB dla Emacsa.

%prep
%setup -q

%{__sed} -i -e '1s,/usr/bin/env python,/usr/bin/python,' support/scripts/as2gbmap.py

cp -p %{SOURCE1} doc/MCS51_named.pdf

%build
%configure \
	PDFOPT=/bin/cp \
	%{__enable_disable doc} \
	--enable-libgc \
	--enable-ucsim \
	--enable-xa \
	--enable-serio \
	--enable-statistic

%{__make} -j1

%{__make} -C device/lib -j1 model-mcs51-stack-auto model-mcs51-xstack-auto

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT%{_datadir}/emacs/site-lisp

%{__make} install \
	"DESTDIR=$RPM_BUILD_ROOT" \
	"docdir=%{_docdir}/%{name}-%{version}" \
	"STRIP=/bin/true"

%{__mv} $RPM_BUILD_ROOT%{_bindir}/*.el $RPM_BUILD_ROOT%{_datadir}/emacs/site-lisp

%{__rm} $RPM_BUILD_ROOT%{_infodir}/bfd.info*

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc %{_docdir}/%{name}-%{version}
%attr(755,root,root) %{_bindir}/as2gbmap
%attr(755,root,root) %{_bindir}/makebin
%attr(755,root,root) %{_bindir}/packihx
%attr(755,root,root) %{_bindir}/s51
%attr(755,root,root) %{_bindir}/sdar
%attr(755,root,root) %{_bindir}/sdas*
%attr(755,root,root) %{_bindir}/sdcc
%attr(755,root,root) %{_bindir}/sdcclib
%attr(755,root,root) %{_bindir}/sdcdb
%attr(755,root,root) %{_bindir}/sdcpp
%attr(755,root,root) %{_bindir}/sdld*
%attr(755,root,root) %{_bindir}/sdnm
%attr(755,root,root) %{_bindir}/sdobjcopy
%attr(755,root,root) %{_bindir}/sdranlib
%attr(755,root,root) %{_bindir}/shc08
%attr(755,root,root) %{_bindir}/sstm8
%attr(755,root,root) %{_bindir}/sz80
%{_datadir}/%{name}

%files -n emacs-sdcdb
%defattr(644,root,root,755)
%{_datadir}/emacs/site-lisp/sdcdb.el
%{_datadir}/emacs/site-lisp/sdcdbsrc.el
%changelog
* Tue Oct 18 2016 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/sdcc.git;a=log;h=master

* Tue Oct 18 2016 Jan Rękorajski <baggins@pld-linux.org> 3582bfd
- rebuild with readline 7.0
- release 3 (by relup.sh)

* Wed Aug 03 2016 Jakub Bogusz <qboosh@pld-linux.org> 2d99840
- release 2

* Wed Aug 03 2016 Jakub Bogusz <qboosh@pld-linux.org> 4448e4a
- use already generated MCS51_named.pdf to fix build with (too old) texlive 2008
- ensure gputils 1.4.2+ for more chips support

* Sun Jul 17 2016 Jakub Bogusz <qboosh@pld-linux.org> 491b2b3
- BR: texlive-tex-xkeyval (required by tex/latex/xkeyval/xkeyval.sty from texinfo-latex)

* Sun Jul 17 2016 Jakub Bogusz <qboosh@pld-linux.org> 079010b
- updated to 3.6.0

* Sun Apr 17 2016 Jan Rękorajski <baggins@pld-linux.org> 5833841
- release 2 (by relup.sh)

* Fri Apr 15 2016 Arkadiusz Miśkiewicz <arekm@maven.pl> f313c56
- up to 3.5.0

* Tue Jul 29 2014 Jan Rękorajski <baggins@pld-linux.org> f81fe68
- site-lisp is under data-dir
- rel 3

* Sat Jul 26 2014 Jan Rękorajski <baggins@pld-linux.org> 0702cec
- release 2 (by relup.sh)

* Fri Jul 25 2014 Jakub Bogusz <qboosh@pld-linux.org> ea490d2
- updated to 3.4.0, cleanup, separated emacs files

* Thu Dec 05 2013 Jan Rękorajski <baggins@pld-linux.org> 76352ee
- pdfopt is long dead and gone, fool  configure with cp

* Sun Jul 21 2013 Witold Filipczyk <witekfl@poczta.onet.pl> edea816
- up to 3.3.0

* Sun Mar 24 2013 witekfl <witekfl@poczta.onet.pl> 100f1d1
- snapshot 20130324; commented old patches; BR: texlive-xetex

* Tue Aug 03 2010 kosmo <kosmo@pld-linux.org> cc5ed3e
- updated to snap 20100803

* Mon Jun 21 2010 kosmo <kosmo@pld-linux.org> 8fa97a0
- updated to snap 20100614

* Tue Feb 02 2010 sparky <sparky@pld-linux.org> ad45c64
- added without doc bcond
- readded as-build patch
- dropped BR: automake

* Tue Feb 02 2010 sparky <sparky@pld-linux.org> 7e515d8
- readded, with directory names updated

* Tue Feb 02 2010 kosmo <kosmo@pld-linux.org> d3d5e2d
- outdated, removed.

* Tue Feb 02 2010 kosmo <kosmo@pld-linux.org> e2899b4
- updated to 2.9.7 (snap 20100201).

* Wed Nov 11 2009 kosmo <kosmo@pld-linux.org> 20adacc
- updated to 2.9.4 (snap 20091108)
- fixed build on SMP machines.

